import CoreApp, { compose } from 'fusion-core';
import { PreparePlugin, prepare } from 'fusion-react-async';
import ReactDOM from 'react-dom';
import React from 'react';
import PropTypes from 'prop-types';

/* eslint-env node */

/* eslint-env browser */
var clientRender = (function (el) {
  var domElement = document.getElementById('root');
  ReactDOM.hydrate ? ReactDOM.hydrate(el, domElement) : ReactDOM.render(el, domElement);
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _classCallCheck$1(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn$1(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits$1(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Provider = {
  create: function create(name) {
    var _extends2;

    var BaseComponent = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : React.Component;

    var Provider = function (_BaseComponent) {
      _inherits$1(Provider, _BaseComponent);

      function Provider() {
        _classCallCheck$1(this, Provider);

        return _possibleConstructorReturn$1(this, _BaseComponent.apply(this, arguments));
      }

      Provider.prototype.getChildContext = function getChildContext() {
        var _ref;

        return _ref = {}, _ref[name] = this.props.service, _ref;
      };

      Provider.prototype.render = function render() {
        return React.Children.only(this.props.children);
      };

      return Provider;
    }(BaseComponent);

    Provider.childContextTypes = _extends({}, Provider.childContextTypes || {}, (_extends2 = {}, _extends2[name] = PropTypes.object.isRequired, _extends2));
    Provider.displayName = name.replace(/^./, function (c) {
      return c.toUpperCase();
    }) + 'Provider';

    return Provider;
  }
};

var plugin = {
  create: function create(name, plugin, BaseComponent) {
    return function () {
      var p = plugin.apply(undefined, arguments);
      var middleware = p.middleware;
      var ProviderComponent = Provider.create(name, BaseComponent);
      p.middleware = function (ctx, next) {
        if (ctx.element) {
          ctx.element = React.createElement(ProviderComponent, { service: this.of(ctx) }, ctx.element);
        }
        return middleware.call(p, ctx, next);
      };
      return p;
    };
  }
};

var _extends$1 = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _classCallCheck$2(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn$2(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits$2(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var hoc = {
  create: function create(name, mapServiceToProps) {
    if (!mapServiceToProps) {
      mapServiceToProps = function mapServiceToProps(service) {
        var _ref;

        return _ref = {}, _ref[name] = service, _ref;
      };
    }
    return function (Component) {
      var _HOC$contextTypes;

      var HOC = function (_React$Component) {
        _inherits$2(HOC, _React$Component);

        function HOC(props, ctx) {
          _classCallCheck$2(this, HOC);

          var _this = _possibleConstructorReturn$2(this, _React$Component.call(this, props, ctx));

          _this.service = ctx[name];
          return _this;
        }

        HOC.prototype.render = function render() {
          var props = _extends$1({}, this.props, mapServiceToProps(this.service));
          return React.createElement(Component, props);
        };

        return HOC;
      }(React.Component);

      var displayName = Component.displayName || Component.name;
      HOC.displayName = 'With' + name.replace(/^./, function (c) {
        return c.toUpperCase();
      }) + '(' + displayName + ')';
      HOC.contextTypes = (_HOC$contextTypes = {}, _HOC$contextTypes[name] = PropTypes.object.isRequired, _HOC$contextTypes);
      return HOC;
    };
  }
};

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/* eslint-env browser */
var App = function (_CoreApp) {
  _inherits(App, _CoreApp);

  function App(root) {
    _classCallCheck(this, App);

    var _this = _possibleConstructorReturn(this, _CoreApp.call(this, root, function (el) {
      return prepare(el).then(function () {
        return clientRender(el);
      });
    }));

    _this.plugins.push(compose([PreparePlugin(), _this.plugins.pop()]));
    return _this;
  }

  return App;
}(CoreApp);

export { plugin as ProviderPlugin, hoc as ProvidedHOC, Provider };export default App;
//# sourceMappingURL=browser.es.js.map
